(*
	TARPROTECTOR V1.0
	By
	Albert Research 98
	We do it right !!!

	WEB Page: http://personal.redestb.es/albertrs/
	E-mail: albertrs@redestb.es

	Enjoy the object ! Any comments don't doubt to send me and e-mail. Look at the help file for any questions.

		  -
	   _ +*+ _
	 _+ +_ _+*+_                   
	++_   ****_++
    _+_   +_ **_+   _+_
  _+   +_   +*+   _+***+_
 +_      +_     _+******_+
   +_      +_ _+******_+
     +_      *******_+
	+_    *****_+
	  +_  ***_+
		+_*_+
		  +


*)
unit ARProtector;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,StdCtrls,ExtCtrls,Dsgnintf;

type
	{About on Property Editor}
	TAboutProperty = class(TPropertyEditor)
	public
		procedure Edit; override;
		function GetAttributes: TPropertyAttributes; override;
		function GetValue: string; override;
	end;

  TARProtector = class(TComponent)
  private
    { Private declarations }
    VAppOnMessage				: TMessageEvent;
    VHooked					: boolean;
    VOnHook					: TNotifyEvent;
    VTimeOff					: TTime;
//    VLabel						: TLabel; {For Test the Object}
    VTimer						: TTimer;

    {Visible Properties}
    VEnabled					: boolean;
    VMinutes					: integer;
    VSeconds					: integer;
    VAbout		 				: TAboutProperty;

  protected
    { Protected declarations }
    procedure AppOnMessage(var Msg : TMsg; var Handled: Boolean);
    procedure PSetVEnabled(Value: Boolean);
    procedure PSetVMinutes(Value: integer);
    procedure PSetVSeconds(Value: integer);
    procedure SetTimeOff;
    procedure POnTimer(Sender: TObject);
  public
    { Public declarations }
    constructor Create(AOwner : TComponent);override;
    destructor Destroy; override;

  published
    { Published declarations }
    property Author: TAboutProperty read VAbout write VAbout;
    property OnIdle : TNotifyEvent read VOnHook write VOnHook;
    property Enabled: Boolean read VEnabled write PSetVEnabled;
    property IdleMinutes: integer read VMinutes write PSetVMinutes;
    property IdleSeconds: integer read VSeconds write PSetVSeconds;
//    property ALabel: TLabel read VLabel write VLabel; {For Test the Object}
  end;

procedure Register;

implementation


constructor TARProtector.Create(AOwner : TComponent);
begin
	inherited Create(AOwner);


	VMinutes := 1;
	VSeconds := 0;
	VEnabled := True;
	VHooked := False;
	VTimer := nil;

	SetTimeOff;

	if not (csDesigning in ComponentState) then
		begin
			VAppOnMessage := Application.OnMessage;
			Application.OnMessage := AppOnMessage;

			VTimer := TTimer.Create(Self);
			VTimer.OnTimer := POnTimer;
			Vtimer.Interval := 1000;
			VTimer.Enabled := VEnabled;
		end;

end;
destructor TARProtector.Destroy;
begin
	if VTimer <> nil then
		begin
			VTimer.Enabled := False;
			Vtimer.Free;
		end;

	if Assigned(VAppOnMessage) then
		begin
			Application.OnMessage := VAppOnMessage;
		end;
	inherited Destroy;
end;

procedure TARProtector.AppOnMessage(var Msg : TMsg; var Handled: Boolean);
begin
	if csDesigning in ComponentState then
		exit;

	if VHooked then
		begin
			if Assigned(VAppOnMessage) then
				VAppOnMessage(Msg,Handled);
			exit;
		end;



	if Assigned(VAppOnMessage) then
		VAppOnMessage(Msg,Handled);


	if (Msg.message = WM_MOUSEMOVE) OR (Msg.message = WM_KEYDOWN) then
		begin
			SetTimeOff;
		end;


end;

procedure TARProtector.PSetVEnabled(Value: Boolean);
begin
	if Value <> VEnabled then
		begin
			VEnabled := Value;
			
			if not (csDesigning in ComponentState) then
				begin
					Vtimer.Enabled := VEnabled;
				end;
		end;
end;
procedure TARProtector.PSetVMinutes(Value: integer);
begin
	if (Value < 0) OR (Value > 30) then
		begin
			MessageDlg('Minutes must be Between 0 and 30',mtInformation,[mbOk],0);
			exit;
		end;

	VMinutes := Value;

	SetTimeOff;	

end;

procedure TARProtector.PSetVSeconds(Value: integer);
begin
	if (Value < 0) OR (Value > 59) then
		begin
			MessageDlg('Seconds must be Between 0 and 59',mtInformation,[mbOk],0);
			exit;
		end;

	VSeconds := Value;

	SetTimeOff;	
end;

procedure TARPRotector.SetTimeOff;
var
	Hora,Minutos,Segundos	: integer;
	HoraTexto24				: string;
	HoraTexto12				: string;
begin

	HoraTexto24 := FormatDateTime('hhmmss',Time);
	Hora := StrToInt(Copy(HoraTexto24,1,2));
	Minutos := StrToInt(Copy(HoraTexto24,3,2));
	Segundos := StrToInt(Copy(HoraTexto24,5,2));

	Segundos := Segundos + VSeconds;

	if Segundos > 59 then
		begin
			inc(Minutos);
			Segundos := Segundos - 60;
		end;

	Minutos := Minutos + VMinutes;

	if Minutos > 59 then
		begin
			inc(Hora);
			Minutos := Minutos - 60;
		end;

	if Hora > 23 then
		begin
			Hora := Hora - 24;
		end;

	HoraTexto24 := Format('%.2d:%.2d:%.2d',[Hora,Minutos,Segundos]);
	if Hora > 12 then
		begin
			Hora := abs(Hora -12);
		end;
	HoraTexto12 := Format('%d:%d:%d',[Hora,Minutos,Segundos]);
	try
		VTimeOff := StrToTime(HoraTexto24);
	except
		VTimeOff := StrToTime(HoraTexto12);	
	end;


end;

procedure TARProtector.POnTimer(Sender: TObject);
//var
//	Hora,HoraFinal			: String; {For Test the Object}
begin
	if VHooked then
		exit;
		
{	if Vlabel <> nil then
		begin
			Hora := FormatDateTime('hh:mm:ss',Time);
			HoraFinal := FormatDateTime('hh:mm:ss',VTimeOff);
			VLabel.Caption := Hora + '  ' + HoraFinal;
		end;}

	if VTimeOff <= Time then
		begin
			VHooked := True;
			if Assigned(VOnHook) then
				VOnHook(Self);

			VHooked := False;
			SetTimeOff;
			exit;
		end;
		

end;

{ TAboutProperty }
procedure TAboutProperty.Edit;
var
	VForm				: TForm;
	VButton				: TButton;
	VLabel				: TLabel;
begin
	VForm := TForm.Create(nil);
	VButton := TButton.Create(VForm);
	VLabel := TLabel.Create(VForm);

	VButton.Width := 60;
	VButton.Height := 21;
	VButton.Left := 96;
	VButton.Top := 136;
	VButton.Caption := 'Ok';
	VButton.ModalResult := mrOk;
	Vbutton.Parent := VForm;

	VLabel.Width := 248;
	VLabel.Height := 140;
	VLabel.Left := 10;
	VLabel.Top := 4;
	VLabel.AutoSize := False;
	VLabel.Caption := 'ARProtector V1.0'+#10+#10+'Aplication protection during a certain Idle Time.'+#10+'This Object is FreeWare so you can Distribute it '+#10+'to any other Person.'+#10+#10+'E-Mail: albertrs@redestb.es'+#10+#10+'WWW: http://personal.redestb.es/albertrs/'+#10+#10;
	VLabel.Parent := VForm;

	VForm.BorderStyle := bsToolWindow;
	VForm.Width := 256;
	VForm.Height := 190;
	VForm.Position := poScreenCenter;
	VForm.Caption := 'Albert Research 98 ARProtector V1.0';
	VForm.ShowModal;

end;

function TAboutProperty.GetAttributes: TPropertyAttributes;
begin
	Result := [paMultiSelect, paDialog, paReadOnly];
end;

function TAboutProperty.GetValue: string;
begin
	Result := 'Albert Research 98';
end;

procedure Register;
begin
	RegisterComponents('Albert Research', [TARProtector]);
	RegisterPropertyEditor(TypeInfo(TAboutProperty), TARProtector, 'Author', TAboutProperty);
end;

end.
